// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             (unknown)
// source: proto/health_service.proto

package proto

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	HealthService_ReadinessProbe_FullMethodName = "/gitlab.cells.topology_service.HealthService/ReadinessProbe"
	HealthService_LivenessProbe_FullMethodName  = "/gitlab.cells.topology_service.HealthService/LivenessProbe"
)

// HealthServiceClient is the client API for HealthService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// Public read-only service
type HealthServiceClient interface {
	// (Lightweight) Used for checking if application is ready to accept requests
	ReadinessProbe(ctx context.Context, in *ReadinessProbeRequest, opts ...grpc.CallOption) (*ReadinessProbeResponse, error)
	// (Lightweight) Used for checking if application is alive, or whether it should be restarted
	LivenessProbe(ctx context.Context, in *LivenessProbeRequest, opts ...grpc.CallOption) (*LivenessProbeResponse, error)
}

type healthServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewHealthServiceClient(cc grpc.ClientConnInterface) HealthServiceClient {
	return &healthServiceClient{cc}
}

func (c *healthServiceClient) ReadinessProbe(ctx context.Context, in *ReadinessProbeRequest, opts ...grpc.CallOption) (*ReadinessProbeResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(ReadinessProbeResponse)
	err := c.cc.Invoke(ctx, HealthService_ReadinessProbe_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *healthServiceClient) LivenessProbe(ctx context.Context, in *LivenessProbeRequest, opts ...grpc.CallOption) (*LivenessProbeResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(LivenessProbeResponse)
	err := c.cc.Invoke(ctx, HealthService_LivenessProbe_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// HealthServiceServer is the server API for HealthService service.
// All implementations must embed UnimplementedHealthServiceServer
// for forward compatibility.
//
// Public read-only service
type HealthServiceServer interface {
	// (Lightweight) Used for checking if application is ready to accept requests
	ReadinessProbe(context.Context, *ReadinessProbeRequest) (*ReadinessProbeResponse, error)
	// (Lightweight) Used for checking if application is alive, or whether it should be restarted
	LivenessProbe(context.Context, *LivenessProbeRequest) (*LivenessProbeResponse, error)
	mustEmbedUnimplementedHealthServiceServer()
}

// UnimplementedHealthServiceServer must be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedHealthServiceServer struct{}

func (UnimplementedHealthServiceServer) ReadinessProbe(context.Context, *ReadinessProbeRequest) (*ReadinessProbeResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ReadinessProbe not implemented")
}
func (UnimplementedHealthServiceServer) LivenessProbe(context.Context, *LivenessProbeRequest) (*LivenessProbeResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method LivenessProbe not implemented")
}
func (UnimplementedHealthServiceServer) mustEmbedUnimplementedHealthServiceServer() {}
func (UnimplementedHealthServiceServer) testEmbeddedByValue()                       {}

// UnsafeHealthServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to HealthServiceServer will
// result in compilation errors.
type UnsafeHealthServiceServer interface {
	mustEmbedUnimplementedHealthServiceServer()
}

func RegisterHealthServiceServer(s grpc.ServiceRegistrar, srv HealthServiceServer) {
	// If the following call pancis, it indicates UnimplementedHealthServiceServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&HealthService_ServiceDesc, srv)
}

func _HealthService_ReadinessProbe_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ReadinessProbeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(HealthServiceServer).ReadinessProbe(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: HealthService_ReadinessProbe_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(HealthServiceServer).ReadinessProbe(ctx, req.(*ReadinessProbeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _HealthService_LivenessProbe_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(LivenessProbeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(HealthServiceServer).LivenessProbe(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: HealthService_LivenessProbe_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(HealthServiceServer).LivenessProbe(ctx, req.(*LivenessProbeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// HealthService_ServiceDesc is the grpc.ServiceDesc for HealthService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var HealthService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "gitlab.cells.topology_service.HealthService",
	HandlerType: (*HealthServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "ReadinessProbe",
			Handler:    _HealthService_ReadinessProbe_Handler,
		},
		{
			MethodName: "LivenessProbe",
			Handler:    _HealthService_LivenessProbe_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "proto/health_service.proto",
}
